﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using NavigationListControl;
using WindowsPhoneMVVMExample.ViewModel;
using System.ComponentModel;
using LinqToVisualTree;
using System.Windows.Controls.Primitives;
using System.Diagnostics;

namespace WindowsPhoneMVVMExample
{
  public partial class FeedView : PhoneApplicationPage
  {
    private static readonly string ScrollOffsetKey = "ScrollOffsetKey";
    
    public FeedView()
    {
      InitializeComponent();
    }

    private void NavigationList_Navigation(object sender, NavigationEventArgs e)
    {
      var selectedItem = e.Item as FeedItemViewModel;

      // navigate to the feed items page
      NavigationService.Navigate(new Uri("/FeedItemView.xaml?id=" + selectedItem.Id, UriKind.Relative));
    }
    
    /// <summary>
    /// Gets the NavigationList ItemsPanel
    /// </summary>
    private VirtualizingStackPanel ItemsPanel
    {
      get
      {
        return navigationControl.Descendants<VirtualizingStackPanel>()
                                .Cast<VirtualizingStackPanel>()
                                .SingleOrDefault();
      }
    }

    protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
    {
      base.OnNavigatedFrom(e);

      // persist the scroll position within the page state
      var scroll = ItemsPanel;
      if (scroll != null)
      {
        State[ScrollOffsetKey] = ItemsPanel.ScrollOwner.VerticalOffset;
      }
    }

    protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
    {
      base.OnNavigatedTo(e);

      // restore the scroll position
      this.Loaded += (s, e2) =>
        {
            if (State.ContainsKey(ScrollOffsetKey))
            {
              var scroll = ItemsPanel;
              if (scroll != null)
              {
                ItemsPanel.SetVerticalOffset((double)State[ScrollOffsetKey]);
              }
            }
        };
    }

   
  }
}